<?php

defined('_JEXEC') or die;

 /* xhtml (divs and font header tags)
 * With the new advanced parameter it does the same as the html5 chrome
 */
function modChrome_id($module, &$params, &$attribs)
{
	$moduleTag      = $params->get('module_tag', 'div');
	$headerTag      = htmlspecialchars($params->get('header_tag', 'h3'), ENT_COMPAT, 'UTF-8');
	$bootstrapSize  = (int) $params->get('bootstrap_size', 0);
	$moduleClass    = $bootstrapSize != 0 ? ' span' . $bootstrapSize : '';

	// Temporarily store header class in variable
	$headerClass    = $params->get('header_class');
	$headerClass    = !empty($headerClass) ? ' class="' . htmlspecialchars($headerClass, ENT_COMPAT, 'UTF-8') . '"' : '';
	$headerId    = $params->get('header_class');
	$headerId	    = !empty($headerId) ? ' id="' . htmlspecialchars($headerId, ENT_COMPAT, 'UTF-8') . '"' : '';

	if (!empty ($module->content)) : ?>
		<<?php echo $moduleTag; ?> class="section<?php echo htmlspecialchars($params->get('moduleclass_sfx'), ENT_COMPAT, 'UTF-8') . $moduleClass; ?>" <?php echo $headerId ?>>
			<?php if ((bool) $module->showtitle) : ?>
				<<?php echo $headerTag . $headerClass . '>' . $module->title; ?></<?php echo $headerTag; ?>>
			<?php endif; ?>
			<?php echo $module->content; ?>
		</<?php echo $moduleTag; ?>>
	<?php endif;
}

 /* xhtml (divs and font header tags)
 * With the new advanced parameter it does the same as the html5 chrome
 */
function modChrome_carousel($module, &$params, &$attribs)
{
	$moduleTag      = $params->get('module_tag', 'div');
	$headerTag      = htmlspecialchars($params->get('header_tag', 'h3'), ENT_COMPAT, 'UTF-8');
	$bootstrapSize  = (int) $params->get('bootstrap_size', 0);
	$moduleClass    = $bootstrapSize != 0 ? ' span' . $bootstrapSize : '';
	$itemCount		= $params->get('count', 5);
	
	// Temporarily store header class in variable
	$headerClass    = $params->get('header_class');
	$headerClass    = !empty($headerClass) ? ' class="' . htmlspecialchars($headerClass, ENT_COMPAT, 'UTF-8') . '"' : '';
	$headerId    = $params->get('header_class');
	$headerId	    = !empty($headerId) ? ' id="' . htmlspecialchars($headerId, ENT_COMPAT, 'UTF-8') . '"' : '';
	
	if (!empty ($module->content)) : ?>
		<<?php echo $moduleTag; ?> class="section<?php echo htmlspecialchars($params->get('moduleclass_sfx'), ENT_COMPAT, 'UTF-8') . $moduleClass; ?> gallery autoplay items-<?php echo $itemCount ?>" <?php echo $headerId ?>>
        <?php if ((bool) $module->showtitle) : ?>
			<<?php echo $headerTag . $headerClass . '>' . $module->title; ?></<?php echo $headerTag; ?>>
		<?php endif; ?>
            <?php $operatorcount = 1; ?>
            <?php for ($i = 0, $n = $itemCount; $i < $n; $i ++) : ?>
                <?php $item = $list[$i]; ?>
              <div id="item-<?php echo $operatorcount ?>" class="control-operator"></div>
              <?php $operatorcount++; ?>
            <?php endfor; ?>
              <?php echo $module->content; ?>
              <div class="controls">
              <?php $controlcount = 1; ?>
              <?php for ($i = 0, $n = $itemCount; $i < $n; $i ++) : ?>
                <?php $item = $list[$i]; ?>
                <a href="#item-<?php echo $controlcount ?>" class="control-button">•</a>
                <?php $controlcount++; ?>
            <?php endfor; ?>
              </div>
       </<?php echo $moduleTag; ?>>
	<?php endif;
}

